﻿var SHTSLLC = SHTSLLC || {};

SHTSLLC.SiteCollection = {};
SHTSLLC.Site = {};
SHTSLLC.ServerRelativeUrl = "";
SHTSLLC.Context = {};
SHTSLLC.Views = {};
SHTSLLC.PrintView = {};
SHTSLLC.List = {};
SHTSLLC.Header = {};
SHTSLLC.PrintView = function () {

    var appWebUrl,
        hostUrl,
        siteUrl,
        listId,
        viewUrl,

        set_appWebUrl = function (v) { appWebUrl = v; },
        set_hostUrl = function (v) { hostUrl = v; },
        set_siteUrl = function (v) { siteUrl = v; },
        set_listId = function (v) { listId = v; },
        set_viewUrl = function (v) { viewUrl = v; },

        execute = function () {
            var ctx = new SP.ClientContext(appWebUrl);
            var factory = new SP.ProxyWebRequestExecutorFactory(appWebUrl);
            ctx.set_webRequestExecutorFactory(factory);
            var appContextSite = new SP.AppContextSite(ctx, hostUrl);
            SHTSLLC.Site = appContextSite.get_web();
            ctx.load(SHTSLLC.Site);
            ctx.executeQueryAsync(getSiteSuccess, failure);
        },

        getQueryStringValue = function (paramName) {
            try {
                var params = decodeURIComponent(location.href).split("?")[1].split("&");
                var strParams = "";
                for (var i = 0; i < params.length; i = i + 1) {
                    var singleParam = params[i].split("=");
                    if (singleParam[0] == paramName)
                        return decodeURIComponent(singleParam[1]);
                }
            }
            catch (err)
            { return null; }
        },

        getSiteSuccess = function () {
            var ctx = new SP.ClientContext.get_current();
            SHTSLLC.SiteCollection = ctx.get_site();
            ctx.load(SHTSLLC.SiteCollection);
            var site = SHTSLLC.SiteCollection.openWeb(SHTSLLC.Site.get_serverRelativeUrl());
            ctx.load(site);
            var lists = site.get_lists();
            ctx.load(lists);
            SHTSLLC.List = lists.getById(listId);
            ctx.load(SHTSLLC.List);
            SHTSLLC.Views = SHTSLLC.List.get_views();
            ctx.load(SHTSLLC.Views);
            ctx.executeQueryAsync(getViewsSuccess, failure);
        },

        getViewsSuccess = function () {
            var ctx = new SP.ClientContext.get_current();
            var viewEnumerator = SHTSLLC.Views.getEnumerator();
            var currentView = null;
            var defaultView = null;
            var printView = null;
            var view = null;

            while (viewEnumerator.moveNext()) {
                if (viewUrl.indexOf(viewEnumerator.get_current().get_serverRelativeUrl()) > -1) {
                    currentView = viewEnumerator.get_current();
                }
                if (viewEnumerator.get_current().get_defaultView()) {
                    defaultView = viewEnumerator.get_current();
                }
                if (viewEnumerator.get_current().get_title() === "Print") {
                    printView = viewEnumerator.get_current();
                }
            }

            var printViewSettingVal = SHTSLLC.Settings.readSetting("PrintView").get_value();

            switch (printViewSettingVal) {

                case "Current":
                    if (currentView !== null) {
                        view = currentView;
                        SHTSLLC.Header = currentView.get_title();
                    }
                    else {
                        view = defaultView;
                        SHTSLLC.Header = view.get_title();
                    }
                    break;

                case "Print":
                    if (printView !== null) {
                        view = printView;
                        SHTSLLC.Header = SHTSLLC.List.get_title();
                    }
                    else {
                        view = defaultView;
                        SHTSLLC.Header = view.get_title();
                    }
                    break;

                default:
                    view = defaultView;
                    SHTSLLC.Header = view.get_title();
                    break;
            }

            SHTSLLC.PrintView = view.renderAsHtml();
            ctx.executeQueryAsync(getPrintViewSuccess, failure);
        },

        getPrintViewSuccess = function () {
            $("#returnLink").html(SHTSLLC.Header);
            $("#returnLink").attr("href", document.referrer);
            $("#printDiv").html(SHTSLLC.PrintView.get_value());
            window.print();
        },

        failure = function (sender, args) {
            alert("Sorry, something went wrong while rendering the print view. " + args.get_message());
        };

    return {
        execute: execute,
        set_hostUrl: set_hostUrl,
        set_appWebUrl: set_appWebUrl,
        set_siteUrl: set_siteUrl,
        set_listId: set_listId,
        set_viewUrl: set_viewUrl,
        getQueryStringValue: getQueryStringValue
    };

}();
